package answer;

public class Answer {
      
    public Answer(
            String pContent,
            boolean pCorrectValue,
            int pCost,
            int pPenalty )
            throws IllegalArgumentException {
        
        if( pContent == null ) {
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        if( pContent.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Content argument." );
        }
        
        mContent = new String( pContent );
        mCorrectValue = pCorrectValue;
        setCost( pCost );
        setPenalty( pPenalty );
    }
    
    public Answer(
            Answer pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mContent = new String( pPrototype.mContent );
        mCorrectValue = pPrototype.mCorrectValue;
        setCost( pPrototype.mCost );
        setPenalty( pPrototype.mPenalty );
    }
    
    public boolean setContent(
            String pContent ) {
        
        if( pContent == null )  {
            return false;
        }
        if( pContent.trim().length() == 0 ) {
            return false;
        }
        mContent = new String( pContent );
        return true;
    }
    
    public String getContent() {
        
        return new String( mContent );
    }
    
    public void setCorrectValue(
            boolean pCorrectValue ) {
        
        mCorrectValue = pCorrectValue;
    }
    
    public boolean getCorrectValue() {
        
        return mCorrectValue;
    }
    
    public void setCost(
            int pCost ) {
        
        if( pCost < cPercentageLowBound ) {
            mCost = cPercentageLowBound;
        } else if( pCost > cPercentageHighBound ) {
            mCost = cPercentageHighBound;
        } else {
            mCost = pCost;
        }
    }
    
    public int getCost() {
        
        return mCost;
    }
    
    public void setPenalty(
            int pPenalty ) {
        
        if( pPenalty < cPercentageLowBound ) {
            mPenalty = cPercentageLowBound;
        } else if( pPenalty > cPercentageHighBound ) {
            mPenalty = cPercentageHighBound;
        } else {
            mPenalty = pPenalty;
        }
    }
    
    public int getPenalty() {
        
        return mPenalty;
    }
        
    public Answer clone() {
        
        Answer lClone = null;
        try {
            lClone = new Answer( this );
        } catch( IllegalArgumentException eFake ) {
            
        }
        return lClone;
    }
    
    public boolean equals(
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        } else if( pInstance instanceof Answer ) {
            Answer lInstance = ( Answer )pInstance;
            if( mContent.equals( lInstance.mContent ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private String mContent;
    private boolean mCorrectValue;
    private int mCost;
    private int mPenalty;
    
    private static final int cPercentageLowBound = 0;
    private static final int cPercentageHighBound = 100;
}