package author;

public abstract class Author {
    
    public Author(
            String pName,
            String pSurname )
            throws IllegalArgumentException {
        
        if( pName == null ) {
            throw new IllegalArgumentException( "Illegal Name argument." );
        }
        if( pName.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Name argument." );
        }
        if( pSurname == null ) {
            throw new IllegalArgumentException( "Illegal Surname argument." );
        }
        if( pSurname.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Surname argument." );
        }
        mName = new String( pName );
        mSurname = new String( pSurname );
    }
    
    public Author( 
            Author pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mName = new String( pPrototype.mName );
        mSurname = new String( pPrototype.mSurname );
    }
    
    public boolean setName(
            String pName ) {
        
        if( pName == null )  {
            return false;
        }
        if( pName.trim().length() == 0 ) {
            return false;
        }
        mName = new String( pName );
        return true;
    }
    
    public String getName() {
        
        return new String( mName );
    }
    
    public boolean setSurname(
            String pSurname ) {
        
        if( pSurname == null )  {
            return false;
        }
        if( pSurname.trim().length() == 0 ) {
            return false;
        }
        mSurname = new String( pSurname );
        return true;
    }
    
    public String getSurname() {
        
        return new String( mSurname );
    }
    
    public abstract Author clone();
            
    public boolean equals( 
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        }
        if( pInstance instanceof Author ) {
            Author lInstance = ( Author )pInstance;
            if( mName.equals( lInstance.mName ) &&
                    mSurname.equals( lInstance.mSurname ) ) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }	
	
    private String mName;
    private String mSurname;
}