package author;

public class ForeignAuthor
    extends Author {
    
    public ForeignAuthor(
            String pName,
            String pSecondName,
            String pSurname )
            throws IllegalArgumentException {
        
        super( 
                pName,
                pSurname );
        
        if( pSecondName == null ) {
            throw new IllegalArgumentException( "Illegal SecondName argument." );
        }
        if( pSecondName.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal SecondName argument." );
        }
        
        mSecondName = new String( pSecondName );
    }
    
    public ForeignAuthor(
            ForeignAuthor pPrototype ) {
        
        super(
                pPrototype.getName(),
                pPrototype.getSurname() );
        mSecondName = new String( pPrototype.mSecondName );;
        
    }
    
    public boolean setSecondName(
            String pSecondName ) {
        
        if( pSecondName == null ) {
            return false;
        }
        if( pSecondName.trim().length() == 0 ) {
            return false;
        }
        mSecondName = new String( pSecondName );
        return true;
    }
    
    public String getSecondName() {
        
        return new String( mSecondName );
    }
    
    public ForeignAuthor clone() {
        
        ForeignAuthor lClone = null;
        try {
            lClone =  new ForeignAuthor( this );
        } catch ( IllegalArgumentException eFake ) {
            
        }
        return lClone;
    }
    
    public boolean equals(
            Object pInstance ) {
        
        if( super.equals( pInstance ) ) {
            if( pInstance instanceof SlavicAuthor ) {
                ForeignAuthor lInstance = ( ForeignAuthor ) pInstance;
                if( mSecondName.equals( lInstance.mSecondName ) ) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private String mSecondName;
}