package author;

public class SlavicAuthor 
    extends Author {
    
    public SlavicAuthor(
            String pName,
            String pSurname,
            String pPatronymic )
            throws IllegalArgumentException {
        
        super( 
                pName,
                pSurname );
        
        if( pPatronymic == null ) {
            throw new IllegalArgumentException( "Illegal Patronymic argument." );
        }
        if( pPatronymic.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Patronymic argument." );
        }
        
        mPatronymic = new String( pPatronymic );
    }
    
    public SlavicAuthor(
            SlavicAuthor pPrototype ) {
        
        super(
                pPrototype.getName(),
                pPrototype.getSurname() );
        mPatronymic = new String( pPrototype.mPatronymic );
        
    }
    
    public boolean setPatronymic(
            String pPatronymic ) {
        
        if( pPatronymic == null ) {
            return false;
        }
        if( pPatronymic.trim().length() == 0 ) {
            return false;
        }
        mPatronymic = new String( pPatronymic );
        return true;
    }
    
    public String getPatronymic() {
        
        return new String( mPatronymic );
    }
    
    public SlavicAuthor clone() {
        
        SlavicAuthor lClone = null;
        try {
            lClone =  new SlavicAuthor( this );
        } catch ( IllegalArgumentException eFake ) {
            
        }
        return lClone;
    }
    
    public boolean equals(
            Object pInstance ) {
        
        if( super.equals( pInstance ) ) {
            if( pInstance instanceof SlavicAuthor ) {
                SlavicAuthor lInstance = ( SlavicAuthor ) pInstance;
                if( mPatronymic.equals( lInstance.mPatronymic ) ) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    
    private String mPatronymic;
}