package department;

public class Department {
    
    public Department(
            String pUniversity,
            String pFaculty,
            String pSubFaculty ) {
        
        if( pUniversity == null ) {
            throw new IllegalArgumentException( "Illegal University argument." );
        }
        if( pUniversity.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal University argument." );
        }
        if( pFaculty == null ) {
            throw new IllegalArgumentException( "Illegal Faculty argument." );
        }
        if( pFaculty.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Faculty argument." );
        }
        if( pSubFaculty == null ) {
            throw new IllegalArgumentException( "Illegal SubFaculty argument." );
        }
        if( pSubFaculty.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal SubFaculty argument." );
        }
        
        mUniversity = new String( pUniversity );
        mFaculty = new String( pFaculty );
        mSubFaculty = new String( pSubFaculty );
    }
    
    public Department(
            Department pPrototype ){
        
        if( pPrototype == null ) {
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mUniversity = new String( pPrototype.mUniversity );
        mFaculty = new String( pPrototype.mFaculty );
        mSubFaculty = new String( pPrototype.mSubFaculty );
    }
    
    public boolean setUniversity(
            String pUniversity ) {
        
        if( pUniversity == null )  {
            return false;
        }
        if( pUniversity.trim().length() == 0 ) {
            return false;
        }
        mUniversity = new String( pUniversity );
        return true;
    }
    
    public String getUniversity() {
        
        return new String( mUniversity );
    }
        
    public boolean setFaculty(
            String pFaculty ) {
        
        if( pFaculty == null )  {
            return false;
        }
        if( pFaculty.trim().length() == 0 ) {
            return false;
        }
        mFaculty = new String( pFaculty );
        return true;
    }
    
    public String getFaculty() {
        
        return new String( mFaculty );
    }
        
    public boolean setSubFaculty(
            String pSubFaculty ) {
        
        if( pSubFaculty == null )  {
            return false;
        }
        if( pSubFaculty.trim().length() == 0 ) {
            return false;
        }
        mSubFaculty = new String( pSubFaculty );
        return true;
    }
    
    public String getSubFaculty() {
        
        return new String( mSubFaculty );
    }
    
    public Department clone() {
        
        Department lClone = null;
        try {
            lClone = new Department( this );
        } catch( IllegalArgumentException eFake ) {
            
        }
        return lClone;
    }
    
    public boolean equals(
            Object pInstance ) {
        
        if( pInstance == null ) {
            return false;
        } else if( pInstance instanceof Department ) {
            Department lInstance = ( Department )pInstance;
            if( ( mUniversity.equals( lInstance.mUniversity ) ) && 
                    ( mFaculty.equals( lInstance.mFaculty ) ) && 
                    ( mSubFaculty.equals( lInstance.mSubFaculty ) ) ) {
                return false;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
        
    private String mUniversity;
    private String mFaculty;
    private String mSubFaculty;
}