package test;

import question.Question;
import author.Author;
import department.Department;
import question.Question;

import java.util.Vector;

public class Test {
    
    public Test(
            String pSubject,
            String pTitle,
            Description pDescription,
            Vector< Question > pQuestions )
            throws IllegalArgumentException {
        
        if( pSubject == null ) {
            throw new IllegalArgumentException( "Illegal Subject argument." );
        }
        if( pSubject.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Subject argument." );
        }
        if( pTitle == null ) {
            throw new IllegalArgumentException( "Illegal Title argument." );
        }
        if( pTitle.trim().length() == 0 ) {
            throw new IllegalArgumentException( "Illegal Title argument." );
        }
        if( pDescription == null ) {
            throw new IllegalArgumentException( "Illegal Description argument." );
        }
        if( pQuestions == null ) {
            throw new IllegalArgumentException( "Illegal Questions argument." );
        }
        if( pQuestions.size() == 0 ) {
            throw new IllegalArgumentException( "Illegal Questions argument." );
        }
        mSubject = new String( pSubject );
        mTitle = new String( pTitle );
        mDescription = pDescription.clone();
        mQuestions = ( Vector< Question > )pQuestions.clone();
    }
    
    public Test(
            Test pPrototype )
            throws IllegalArgumentException {
        
        if( pPrototype == null ) {
            throw new IllegalArgumentException( "Illegal Prototype argument." );
        }
        mSubject = new String( pPrototype.mSubject );
        mTitle = new String( pPrototype.mTitle );
        mDescription = pPrototype.mDescription.clone();
        mQuestions = ( Vector< Question > )pPrototype.mQuestions.clone();
    }
    
    public boolean setSubject(
            String pSubject ) {
        
        if( pSubject == null ) {
            return false;
        } else if( pSubject.trim().length() == 0 ) {
            return false;
        } else {
            mSubject = new String( pSubject );
            return true;
        }
    }
    
    public String getSubject() {
        
        return new String( mSubject );
    }
    
    public boolean setTitle(
            String pTitle ) {
        
        if( pTitle == null ) {
            return false;
        } else if( pTitle.trim().length() == 0 ) {
            return false;
        } else {
            mTitle = new String( pTitle );
            return true;
        }
    }
    
    public String getTitle() {
        
        return new String( mTitle );
    }
    
    public boolean setDescription(
            Description pDescription ) {
        
        if( pDescription == null ) {
            return false;
        } else {
            mDescription = pDescription.clone();
            return true;
        }
    }
    
    public Description getDescription() {
        
        return mDescription.clone();
    }
    
    public boolean setQuestions(
            Vector< Question > pQuestions ) {
        
        if( pQuestions == null ) {
            return false;
        } else if( pQuestions.size() == 0 ) {
            return false;
        } else {
            mQuestions = ( Vector< Question > )pQuestions.clone();
            return true;
        }
    }
    
    public Vector< Question > getQuestions() {
        
        return ( Vector< Question > )mQuestions.clone();
    }
    
    private String mSubject;
    private String mTitle;
    private Description mDescription;
    private Vector< Question >  mQuestions;
}